require 'faraday'
require 'yaml'

module Gemshack
  class Client
    class << self
    
      def host
        ENV["GEMSHACK_URL"] || config["host"] || "http://gems.rubykick.com"
      end

      def path
        "/#{api_key}/upload"
      end

      def api_key
        config["api_key"] || "test"
      end

      def push(file)
        client.post(path, {file: upload_io(file)})
      end

      def upload_io(file)
        Faraday::UploadIO.new(file, 'application/gzip')
      end

      def client
        @client ||= Faraday.new(host) do |f|
          f.request :multipart
          f.request :url_encoded
          f.adapter :net_http
        end
      end

      def config
        @config ||= YAML.load_file(File.expand_path("~/.gemshack"))
      end

    end
  end
end
